package it.micegroup.gestioneferie.configurazionepf.entity;

import java.io.Serializable;

import javax.validation.constraints.NotNull;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.PrePersist;
import javax.persistence.PreUpdate;
import javax.persistence.Id;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import java.util.Collection;
import java.util.ArrayList;
import javax.persistence.OneToMany;
import javax.persistence.CascadeType;
import com.fasterxml.jackson.annotation.JsonManagedReference;
import lombok.ToString;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;

import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.Getter;
import lombok.AllArgsConstructor;

import javax.persistence.Table;

import org.apache.commons.lang3.StringUtils;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.hibernate.Hibernate;
import java.util.Objects;

import it.micegroup.gestioneferie.libs.entity.BaseEntity;
import it.micegroup.voila2runtime.utils.EntityUtils;

@NoArgsConstructor

@Getter
@Setter
@Entity
@Table(name = "D_REGOLE_PIANI_FERIE_PK")
public class DregolePianiFeriePk extends BaseEntity implements Serializable {

	// Generated SERIAL VERSION UID
	private static final long serialVersionUID = 3289577936L;

	@SuppressWarnings("unused")
	private static final Logger LOGGER = LogManager.getLogger(DregolePianiFeriePk.class);

	// ATTRIBUTES
	@Id

	@Column(name = "SEQU_ID_REGOLE_PIANI_FERIE_PK", columnDefinition = "NUMBER(15)")
	private Long sequIdRegolePianiFeriePk;
	@NotNull

	@Column(name = "CODI_REGOLA", columnDefinition = "VARCHAR(50)")
	private String codiRegola;
	@NotNull

	@Column(name = "DESC_REGOLA", columnDefinition = "VARCHAR(250)")
	private String descRegola;
	@NotNull

	@Column(name = "FLAG_ELIMINATO", columnDefinition = "VARCHAR(1)")
	private String flagEliminato;
	@NotNull

	@Column(name = "UTENTE_ULTIMA_MODIFICA", columnDefinition = "VARCHAR(50)")
	private String utenteUltimaModifica;
	@NotNull

	@Column(name = "DATA_ULTIMA_MODIFICA", columnDefinition = "DATE")
	private Date dataUltimaModifica;
	@NotNull

	@Column(name = "DATA_INIZIO_VALIDITA", columnDefinition = "DATE")
	private Date dataInizioValidita;
	@NotNull

	@Column(name = "DATA_FINE_VALIDITA", columnDefinition = "DATE")
	private Date dataFineValidita;

	// IMPORTED PARENTS

	// CONSTRUCTORS
	public DregolePianiFeriePk(String objectKey) {
		super();
		setObjectKey(objectKey);
	}

	public DregolePianiFeriePk(String codiRegola, String descRegola, String flagEliminato, String utenteUltimaModifica,
			Date dataUltimaModifica, Date dataInizioValidita, Date dataFineValidita, Long sequIdRegolePianiFeriePk) {
		super();

		this.codiRegola = codiRegola;
		this.descRegola = descRegola;
		this.flagEliminato = flagEliminato;
		this.utenteUltimaModifica = utenteUltimaModifica;
		this.dataUltimaModifica = dataUltimaModifica;
		this.dataInizioValidita = dataInizioValidita;
		this.dataFineValidita = dataFineValidita;
		this.sequIdRegolePianiFeriePk = sequIdRegolePianiFeriePk;
	}

	// CHILDREN
	@JsonProperty(access = Access.WRITE_ONLY)
	@JsonManagedReference("theDregolePianiFeriePk")
	@OneToMany(mappedBy = "theDregolePianiFeriePk", fetch = FetchType.LAZY, cascade = CascadeType.ALL)
	@ToString.Exclude
	private Collection<DregolePianiFerieH> theDregolePianiFerieH = new ArrayList<>();

	// PARENTS

	// GETTER/SETTER
	/**
	 * @return the sequIdRegolePianiFeriePk
	 */
	public Long getSequIdRegolePianiFeriePk() {
		return this.sequIdRegolePianiFeriePk;
	}

	/**
	 * @param sequIdRegolePianiFeriePk to set
	 */
	public void setSequIdRegolePianiFeriePk(Long sequIdRegolePianiFeriePk) {
		this.sequIdRegolePianiFeriePk = sequIdRegolePianiFeriePk;
	}

	/**
	 * @return the codiRegola
	 */
	public String getCodiRegola() {
		return this.codiRegola;
	}

	/**
	 * @param codiRegola to set
	 */
	public void setCodiRegola(String codiRegola) {
		this.codiRegola = codiRegola;
	}

	/**
	 * @return the descRegola
	 */
	public String getDescRegola() {
		return this.descRegola;
	}

	/**
	 * @param descRegola to set
	 */
	public void setDescRegola(String descRegola) {
		this.descRegola = descRegola;
	}

	/**
	 * @return the flagEliminato
	 */
	public String getFlagEliminato() {
		return this.flagEliminato;
	}

	/**
	 * @param flagEliminato to set
	 */
	public void setFlagEliminato(String flagEliminato) {
		this.flagEliminato = flagEliminato;
	}

	/**
	 * @return the utenteUltimaModifica
	 */
	public String getUtenteUltimaModifica() {
		return this.utenteUltimaModifica;
	}

	/**
	 * @param utenteUltimaModifica to set
	 */
	public void setUtenteUltimaModifica(String utenteUltimaModifica) {
		this.utenteUltimaModifica = utenteUltimaModifica;
	}

	/**
	 * @return the dataUltimaModifica
	 */
	public Date getDataUltimaModifica() {
		return this.dataUltimaModifica;
	}

	/**
	 * @param dataUltimaModifica to set
	 */
	public void setDataUltimaModifica(Date dataUltimaModifica) {
		this.dataUltimaModifica = dataUltimaModifica;
	}

	/**
	 * @return the dataInizioValidita
	 */
	public Date getDataInizioValidita() {
		return this.dataInizioValidita;
	}

	/**
	 * @param dataInizioValidita to set
	 */
	public void setDataInizioValidita(Date dataInizioValidita) {
		this.dataInizioValidita = dataInizioValidita;
	}

	/**
	 * @return the dataFineValidita
	 */
	public Date getDataFineValidita() {
		return this.dataFineValidita;
	}

	/**
	 * @param dataFineValidita to set
	 */
	public void setDataFineValidita(Date dataFineValidita) {
		this.dataFineValidita = dataFineValidita;
	}

	// CHILD GETTER/SETTER
	/**
	 * @return the DregolePianiFerieH
	 */
	public Collection<DregolePianiFerieH> getTheDregolePianiFerieH() {
		return theDregolePianiFerieH;
	}

	/**
	 * @param aDregolePianiFerieHList to set
	 */
	public void setTheDregolePianiFerieH(Collection<DregolePianiFerieH> aDregolePianiFerieHList) {
		theDregolePianiFerieH = aDregolePianiFerieHList;
	}

	/// ADD CHILD
	public void addDregolePianiFerieH(DregolePianiFerieH dregolePianiFerieH) {
		theDregolePianiFerieH.add(dregolePianiFerieH);
	}

	// PARENT GETTER/SETTER

	// PARENT ID GETTER/SETTER

	// PARENT OBJECT TITLE

	// PARENT OBJECT KEY

	// IMPORTED PARENT OBJECT KEY

	// OPERATIONS

	// OBJECT KEY
	/**
	 * Restituisce l'identificativo della chiave in formato stringa. Ritorna
	 * conveniente nelle selezioni da lista.
	 * 
	 * @return L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public String getObjectKey() {
		return getObjectKeyById(getSequIdRegolePianiFeriePk());
	}

	public String getObjectKeyById(Long identification) {
		if (identification == null) {
			return null;
		}
		StringBuilder output = new StringBuilder();
		output.append(identification);
		return output.toString();
	}

	/**
	 * Inizializza la parte identificativa del bean in base alla stringa tokenizzata
	 * da "||" fornita in input.
	 * 
	 * @param key L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public void setObjectKey(String key) {
		if (key == null || key.trim().length() == 0) {
			return;
		}
		String[] array = StringUtils.splitByWholeSeparatorPreserveAllTokens(key, getRowIdFieldDelimiter());
		int ctr = 0;

		setSequIdRegolePianiFeriePk(getLongCheckedAgainstNullContent(array[ctr]));
	}

	// OBJECT TITLE
	public String getObjectTitle() {
		StringBuilder output = new StringBuilder();
		output.append(getCodiRegola());
		return output.toString();
	}

	// PREPERSIST

	@PrePersist
	public void prePersist() {
	}

	@PreUpdate
	public void PreUpdate() {
	}

	// Equals / HashCode
	@Override
	public boolean equals(Object o) {
		if (this == o)
			return true;
		if (o == null || Hibernate.getClass(this) != Hibernate.getClass(o))
			return false;
		DregolePianiFeriePk that = (DregolePianiFeriePk) o;
		return sequIdRegolePianiFeriePk != null
				&& Objects.equals(sequIdRegolePianiFeriePk, that.sequIdRegolePianiFeriePk);
	}

	@Override
	public int hashCode() {
		return Objects.hash(sequIdRegolePianiFeriePk);
	}
}
